<script setup lang="ts">
import { useBranchStore } from '@/stores/branch'
import type { Branch } from '@/types/Branch'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const branchStore = useBranchStore()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Branch Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Email',
    key: 'email',
    value: 'email'
  },

  {
    title: 'Branch Address',
    key: 'address',
    value: 'address'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialogDelete = ref(false)
const initialBranch: Branch = {
  id: -1,
  name: '',
  email: '',
  address: '',
  tel: ''
}
const editedBranch = ref<Branch>(JSON.parse(JSON.stringify(initialBranch)))
let editedIndex = -1
let lastId = 8

const page = ref(1)
const itemsPerPage = ref<any>(10)
const pageCount = computed(() => {
  return Math.ceil(branchStore.branchs.length / itemsPerPage.value)
})
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedBranch.value = Object.assign({}, initialBranch)
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await branchStore.deleteBranch(editedBranch.value)
  closeDelete()
}

function editItem(item: Branch) {
  editedBranch.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Branch) {
  editedBranch.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedBranch.value = Object.assign({}, initialBranch)
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await branchStore.saveBranch(editedBranch.value)
}

onMounted(() => {
  branchStore.getBranchs()
})

const search = ref<string>('')

const formattedProducts = computed(() =>
  branchStore.branchs.map((branch) => ({
    ...branch
  }))
)
const filteredUsers = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedProducts.value.filter((product) =>
    product.name.toLowerCase().includes(searchLower)
  )
})
</script>

<template>
  <div>
    <div class="text-center">
      <h1 style="text-align: left" class="ml-5">BRANCH INFO</h1>
    </div>
    <div>
      <v-card-title class="d-flex align-center pe-2">
        <v-spacer></v-spacer>

        <v-dialog v-model="dialog" persistent width="1024">
          <template v-slot:activator="{ props }">
            <div>
              <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
                <v-icon
                  icon="mdi mdi-home-variant"
                  size="25px"
                  class="mr-2"
                  color="#FFFFFF"
                ></v-icon>
                <div style="text-align: left; color: aliceblue">New Branch</div>
              </v-btn>
            </div>
          </template>
          <v-card title="New Branch" class="pt-6" style="text-align: center"
            ><v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedBranch.name"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        class="mb-2"
                        clearable
                        label="Branch Name"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedBranch.email"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        clearable
                        label="Email"
                        placeholder="Enter your Email"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedBranch.address"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        clearable
                        label="Address"
                        placeholder="Enter Branch Address"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-model="editedBranch.tel"
                        :readonly="loading"
                        :rules="[
                          (v) => !!v || 'Field is Field is required',
                          (v) => (v && v.length === 10) || 'Tel. number must be 10 digits',
                          (v) => /^\d+$/.test(v) || 'Tel. number must contain only digits'
                        ]"
                        class="mb-2"
                        clearable
                        label="Tel"
                        placeholder="Enter your tel"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small class="div">*indicates required field</small> </v-card-text
            ><v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="red"
                style="width: 150px; height: 50px"
                variant="flat"
                @click="closeDialog()"
                class="ms-2"
                >Cancel</v-btn
              >

              <v-btn
                style="width: 150px; height: 50px"
                variant="flat"
                @click="save()"
                class="ms-3"
                color="success"
                >Save</v-btn
              >
            </v-card-actions></v-card
          >
        </v-dialog>
        <v-text-field
          v-model="search"
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field>
      </v-card-title>
      <v-dialog v-model="dialogDelete" max-width="500px">
        <v-card>
          <v-card-title class="font ma-4 pt-6" style="text-align: center"
            >you want to delete this info? 🗑️</v-card-title
          >
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="red"
              variant="flat"
              style="width: 150px; height: 50px"
              class="mb-3"
              @click="closeDelete"
              >Cancel</v-btn
            >
            <v-btn
              color="success"
              variant="flat"
              style="width: 150px; height: 50px"
              class="mb-3"
              @click="deleteItemConfirm"
              >OK</v-btn
            >
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
    <div>
      <v-data-table
        v-model:page="page"
        :headers="headers"
        :items="filteredUsers"
        :items-per-page="itemsPerPage"
      >
        <template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div>
        </template>

        <template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
          <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
        </template>
      </v-data-table>
    </div>
  </div>
</template>
<style scoped>
div {
  font-family: 'Kanit';
}
</style>
